
public class StreamCipher {
    // This class encrypts or decrypts a stream of bytes, using a stream cipher.

    public static final int KeySizeBytes = -1;  // IMPLEMENT THIS
    public static final int KeySizeBits = KeySizeBytes*8;

    public static final int NonceSizeBytes = 8;
    public static final int NonceSizeBits = NonceSizeBytes*8;


    public StreamCipher(byte[] key) {
	// <key> is the key, which must be KeySizeBytes bytes in length.

	assert key.length == KeySizeBytes;

	// IMPLEMENT THIS
    }

    public void setNonce(byte[] arr, int offset){
	// Reset to initial state, and set a new nonce.
	// The nonce is in arr[offset] thru arr[offset+NonceSizeBytes-1].
	// It is an error to call setNonce with the same nonce
	//    more than once on a single StreamCipher object.
	// StreamCipher does not check for nonce uniqueness;
	//    that is the responsibility of the caller.

	// IMPLEMENT THIS
    }

    public void setNonce(byte[] nonce) {
	// Reset to initial state, and set a new nonce
	// It is an error to call setNonce with the same nonce
	//    more than once on a single StreamCipher object.
	// StreamCipher does not check for nonce uniqueness;
	//    that is the responsibility of the caller.

	assert nonce.length == NonceSizeBytes;
	setNonce(nonce, 0);
    }

    public byte cryptByte(byte in) {
	// Encrypt/decrypt the next byte in the stream
	return in;   // IMPLEMENT THIS
    }

    public void cryptBytes(byte[] inBuf, int inOffset, 
			   byte[] outBuf, int outOffset, 
			   int numBytes) {
	// Encrypt/decrypt the next <numBytes> bytes in the stream
	// Take input bytes from inBuf[inOffset] thru inBuf[inOffset+numBytes-1]
	// Put output bytes at outBuf[outOffset] thru outBuf[outOffset+numBytes-1];

	// IMPLEMENT THIS
    }
}
