
public class AuthEncryptor {
    // This class is used to compute the authenticated encryption of values.  
    //     Authenticated encryption protects the confidentiality of a value, so that the only 
    //     way to recover the initial value is to do authenticated decryption of the value using the 
    //     same key and nonce that were used to encrypt it.   At the same time, authenticated encryption
    //     protects the integrity of a value, so that a party decrypting the value using
    //     the same key and nonce (that were used to decrypt it) can verify that nobody has tampered with the
    //     value since it was encrypted.

    public static final int KeySizeBytes = -1;   // IMPLEMENT THIS
    public static final int KeySizeBits = KeySizeBytes*8;

    public static final int NonceSizeBytes = StreamCipher.NonceSizeBytes;


    public AuthEncryptor(byte[] key) {
	assert key.length == KeySizeBytes;

	// IMPLEMENT THIS
    }

    public byte[] encrypt(byte[] in, byte[] nonce, boolean includeNonce) {
	// Encrypts the contents of <in> so that its confidentiality and 
	//    integrity are protected against would-be attackers who do 
	//    not know the key that was used to initialize this AuthEncryptor.
	// Callers are forbidden to pass in the same nonce more than once;
	//    but this code will not check for violations of this rule.
	// The nonce will be included as part of the output iff <includeNonce>
	//    is true.  The nonce should be in plaintext if it is included.
	//
	// This returns a newly allocated byte[] containing the authenticated
	//    encryption of the input.

	return null;   // IMPLEMENT THIS
    }
}